Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/handlers/ComputeConcordance.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/handlers/ComputeConcordance.java	(revision 451)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/handlers/ComputeConcordance.java	(revision 452)
@@ -31,13 +31,6 @@
 
 import org.eclipse.core.commands.ExecutionEvent;
 import org.eclipse.core.commands.ExecutionException;
-import org.eclipse.e4.ui.model.application.ui.advanced.MPerspective;
-import org.eclipse.e4.ui.model.application.ui.advanced.impl.PerspectiveStackImpl;
-import org.eclipse.e4.ui.model.application.ui.advanced.impl.PlaceholderImpl;
-import org.eclipse.e4.ui.model.application.ui.basic.MPartSashContainerElement;
-import org.eclipse.e4.ui.model.application.ui.basic.MStackElement;
-import org.eclipse.e4.ui.model.application.ui.basic.impl.PartSashContainerImpl;
-import org.eclipse.e4.ui.model.application.ui.basic.impl.PartStackImpl;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.ui.IEditorPart;
 import org.eclipse.ui.PartInitException;
@@ -192,34 +185,34 @@
 		return true;
 	}
 
-
-	private static void printChildren(Object o, String space) {
-
-		System.out.println(space+o.getClass().getSimpleName()+": "+o);
-		
-		if (o instanceof PlaceholderImpl) {
-			PlaceholderImpl phi = (PlaceholderImpl)o;
-			System.out.println("phi: "+phi);
-		} else if (o instanceof PartSashContainerImpl) {
-			PartSashContainerImpl psci = (PartSashContainerImpl)o;
-			for (MPartSashContainerElement e :psci.getChildren()) {
-				printChildren(e, space+" ");
-			}
-		} else if (o instanceof PerspectiveStackImpl) {
-			PerspectiveStackImpl psi = (PerspectiveStackImpl)o;
-			for (MPerspective p : psi.getChildren()) {
-				printChildren(p,space+" ");
-			}
-		} else if (o instanceof MPerspective) {
-			MPerspective p = (MPerspective)o;
-			for (MPartSashContainerElement e : p.getChildren()) {
-				printChildren(e, space+" ");
-			}
-		} else if (o instanceof PartStackImpl) {
-			PartStackImpl psi = (PartStackImpl)o;
-			for (MStackElement e : psi.getChildren()) {
-				printChildren(e, space+" ");
-			}
-		}
-	}
+// FIXME: tests
+//	private static void printChildren(Object o, String space) {
+//
+//		System.out.println(space+o.getClass().getSimpleName()+": "+o);
+//		
+//		if (o instanceof PlaceholderImpl) {
+//			PlaceholderImpl phi = (PlaceholderImpl)o;
+//			System.out.println("phi: "+phi);
+//		} else if (o instanceof PartSashContainerImpl) {
+//			PartSashContainerImpl psci = (PartSashContainerImpl)o;
+//			for (MPartSashContainerElement e :psci.getChildren()) {
+//				printChildren(e, space+" ");
+//			}
+//		} else if (o instanceof PerspectiveStackImpl) {
+//			PerspectiveStackImpl psi = (PerspectiveStackImpl)o;
+//			for (MPerspective p : psi.getChildren()) {
+//				printChildren(p,space+" ");
+//			}
+//		} else if (o instanceof MPerspective) {
+//			MPerspective p = (MPerspective)o;
+//			for (MPartSashContainerElement e : p.getChildren()) {
+//				printChildren(e, space+" ");
+//			}
+//		} else if (o instanceof PartStackImpl) {
+//			PartStackImpl psi = (PartStackImpl)o;
+//			for (MStackElement e : psi.getChildren()) {
+//				printChildren(e, space+" ");
+//			}
+//		}
+//	}
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java	(revision 452)
@@ -43,7 +43,7 @@
 
 import org.eclipse.osgi.util.NLS;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.functions.Function;
+import org.txm.functions.TXMCommand;
 import org.txm.objects.Base;
 import org.txm.searchengine.cqp.AbstractCqiClient;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
@@ -60,7 +60,7 @@
 /**
  * compute a diagnostic of Corpus, sub corpus and partition @ author mdecorde.
  */
-public class Diagnostic extends Function {
+public class Diagnostic extends TXMCommand {
 	// Base base;
 	/** The corpus. */
 	Corpus corpus;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CorpusManager.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CorpusManager.java	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CorpusManager.java	(revision 452)
@@ -30,7 +30,6 @@
 import java.util.ArrayList;
 import java.util.List;
 
-import org.eclipse.persistence.annotations.Structure;
 import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.searchengine.cqp.AbstractCqiClient;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Partition.java	(revision 452)
@@ -42,7 +42,6 @@
 import java.util.TreeMap;
 
 import org.eclipse.osgi.util.NLS;
-import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.objects.TxmObject;
 import org.txm.searchengine.cqp.CQPEngine;
@@ -57,6 +56,7 @@
 /**
  * A partition on a corpus.
  *
+ * @author mdecorde
  * @author sjacquot 
  * @author Jean-Philippe Magué
  * 
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 452)
@@ -36,7 +36,7 @@
 
 import org.eclipse.osgi.util.NLS;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.core.results.ITXMResult;
+import org.txm.core.results.TXMResult;
 import org.txm.functions.selection.SelectionResult;
 import org.txm.objects.Base;
 import org.txm.objects.TxmObject;
@@ -965,8 +965,8 @@
 	/* (non-Javadoc)
 	 * @see org.txm.HasResults#getSubHasResults()
 	 */
-	public ArrayList<ITXMResult> getSubHasResults() {
-		ArrayList<ITXMResult> subresults = new ArrayList<ITXMResult>();
+	public ArrayList<TXMResult> getSubHasResults() {
+		ArrayList<TXMResult> subresults = new ArrayList<TXMResult>();
 		subresults.addAll(this.getSubcorpora());
 		subresults.addAll(this.getPartitions());
 		return subresults;
@@ -1312,9 +1312,9 @@
 		return cql_limit_query;
 	}
 
-	public ArrayList<ITXMResult> clearResults() {
-		ArrayList<ITXMResult> old = this.children;
-		this.children = new ArrayList<ITXMResult>();
+	public ArrayList<TXMResult> clearResults() {
+		ArrayList<TXMResult> old = this.children;
+		this.children = new ArrayList<TXMResult>();
 		return old;
 	}
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/MemCqiServer.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/MemCqiServer.java	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/MemCqiServer.java	(revision 452)
@@ -167,7 +167,7 @@
 				isLoaded = true;
 
 			} catch (Throwable e) {
-				System.err.println("Failed to load CQP lib with exception: "+e);
+				System.err.println("MemCqiServer: Failed to load CQP lib with exception: "+e);
 				System.err.println("Looking for Cqi libs in : "+System.getProperty("java.library.path")); 
 				System.err.println("Current directory: "+new File(".").getAbsolutePath());
 				throw new Exception(e);
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPEngine.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPEngine.java	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPEngine.java	(revision 452)
@@ -42,17 +42,17 @@
 
 		boolean cqiserverok = false;
 		
-		useNetCQi = Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_NETWORK_MODE));
+		useNetCQi = Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.CQI_NETWORK_MODE, TBXPreferences.PREFERENCES_NODE));
 
 		Log.warning("Killing CQP and RServe process if any");
 		killSearchEngine();
 
 		
-		boolean remote = Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_IS_REMOTE));
+		boolean remote = Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.CQI_SERVER_IS_REMOTE, TBXPreferences.PREFERENCES_NODE));
 		state = false;
 		// test if must-have properties for CWB are set
 
-		String exec_path = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PATH_TO_EXECUTABLE);
+		String exec_path = TXMPreferences.getString(TBXPreferences.CQI_SERVER_PATH_TO_EXECUTABLE, TBXPreferences.PREFERENCES_NODE);
 		String reg_path = ""; // new way that concats registry of loaded corpus
 		String path_separator = System.getProperty("path.separator");
 		for (Base b : Toolbox.workspace.getProject("default").getBases()) {
@@ -78,7 +78,7 @@
 		}
 		if (reg_path.length() > 0) reg_path = reg_path.substring(path_separator.length()); // remove first path_separator
 		//System.out.println("REGPATH="+reg_path);
-		String init_path = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PATH_TO_INIT_FILE);
+		String init_path = TXMPreferences.getString(TBXPreferences.CQI_SERVER_PATH_TO_INIT_FILE, TBXPreferences.PREFERENCES_NODE);
 
 
 		if (!remote) {
@@ -92,9 +92,9 @@
 						cqiServer = new MemCqiServer(exec_path,
 								reg_path, 
 								init_path, 
-								TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS)
-								+ " -P " + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT), //$NON-NLS-1$
-								Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_MONITOR_OUTPUT)));
+								TXMPreferences.getString(TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS, TBXPreferences.PREFERENCES_NODE)
+								+ " -P " + TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE), //$NON-NLS-1$
+								Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.CQI_SERVER_MONITOR_OUTPUT, TBXPreferences.PREFERENCES_NODE)));
 					} catch (Exception e) {
 						// TODO Auto-generated catch block
 						org.txm.utils.logger.Log.printStackTrace(e);
@@ -103,9 +103,9 @@
 					cqiServer = new NetCqiServer(exec_path,
 							reg_path, 
 							init_path, 
-							TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS)
-							+ " -P " + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT), //$NON-NLS-1$
-							Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_MONITOR_OUTPUT)));
+							TXMPreferences.getString(TBXPreferences.CQI_SERVER_ADDITIONAL_OPTIONS, TBXPreferences.PREFERENCES_NODE)
+							+ " -P " + TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE), //$NON-NLS-1$
+							Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.CQI_SERVER_MONITOR_OUTPUT, TBXPreferences.PREFERENCES_NODE)));
 				}
 				if (cqiServer != null)
 					cqiserverok = cqiServer.start();
@@ -123,22 +123,23 @@
 						cqiserverok = false;
 					}
 				} else {
-					int port = Integer.parseInt(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT));
-					String host = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_HOST);
+					int port = Integer.parseInt(TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE));
+					String host = TXMPreferences.getString(TBXPreferences.CQI_SERVER_HOST, TBXPreferences.PREFERENCES_NODE);
 					cqiClient = new NetCqiClient(host, port);
 				}
 			}
 		} catch (NumberFormatException e1) {
-			Log.severe(TXMCoreMessages.Toolbox_wrong_port + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT)); 
+			Log.severe(TXMCoreMessages.Toolbox_wrong_port + TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE)); 
 		} catch (ServerNotFoundException e1) {
-			Log.severe(TXMCoreMessages.Error_CONNECTION_FAILED + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_HOST) + TXMCoreMessages.Toolbox_27 + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT)); 
+			Log.severe(TXMCoreMessages.Error_CONNECTION_FAILED + TXMPreferences.getString(TBXPreferences.CQI_SERVER_HOST, TBXPreferences.PREFERENCES_NODE)
+					+ TXMCoreMessages.Toolbox_27 + TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE)); 
 		}
 
 		// try connecting to the CWB server
 		try {
 			if (cqiserverok) {
-				String login = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_LOGIN);
-				String password = TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PASSWORD);
+				String login = TXMPreferences.getString(TBXPreferences.CQI_SERVER_LOGIN, TBXPreferences.PREFERENCES_NODE);
+				String password = TXMPreferences.getString(TBXPreferences.CQI_SERVER_PASSWORD, TBXPreferences.PREFERENCES_NODE);
 				state = cqiClient.connect(login, password);
 			}
 		} catch (Exception e1) {
@@ -147,10 +148,10 @@
 
 		if (state == false) {
 			System.out.println(TXMCoreMessages.Toolbox_29); 
-			System.out.println(TXMCoreMessages.Toolbox_30 + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_LOGIN) 
-					+ " " + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PASSWORD) 
-					+ TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_HOST) 
-					+ " " + Integer.parseInt(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT))); //$NON-NLS-1$ //$NON-NLS-2$
+			System.out.println(TXMCoreMessages.Toolbox_30 + TXMPreferences.getString(TBXPreferences.CQI_SERVER_LOGIN, TBXPreferences.PREFERENCES_NODE) 
+					+ " " + TXMPreferences.getString(TBXPreferences.CQI_SERVER_PASSWORD, TBXPreferences.PREFERENCES_NODE)  //$NON-NLS-1$
+					+ TXMPreferences.getString(TBXPreferences.CQI_SERVER_HOST, TBXPreferences.PREFERENCES_NODE) 
+					+ " " + Integer.parseInt(TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE))); //$NON-NLS-1$
 			if (cqiServer != null)
 				System.out.println(TXMCoreMessages.Toolbox_33 + cqiServer.getLastCmdLine());
 		} else {
@@ -298,7 +299,7 @@
 	 * kill cqpserver process.
 	 */
 	private static void killSearchEngine() {
-		if ("false".equals(TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_IS_REMOTE))) //$NON-NLS-1$
+		if (!TXMPreferences.getBoolean(TBXPreferences.CQI_SERVER_IS_REMOTE, TBXPreferences.PREFERENCES_NODE))
 			// Windows OS
 			if (OSDetector.isFamilyWindows()) {
 				try {
@@ -331,7 +332,7 @@
 			}
 		// Mac, Linux
 			else {
-				String cmd = TXMCoreMessages.Toolbox_37 + TXMPreferences.getString(TBXPreferences.PREFERENCES_NODE, TBXPreferences.CQI_SERVER_PORT) + TXMCoreMessages.Toolbox_38;
+				String cmd = TXMCoreMessages.Toolbox_37 + TXMPreferences.getString(TBXPreferences.CQI_SERVER_PORT, TBXPreferences.PREFERENCES_NODE) + TXMCoreMessages.Toolbox_38;
 				try {
 					//Process p = Runtime.getRuntime().exec("killall -9 cqpserver"); //$NON-NLS-1$
 					// System.out.println("kill `ps aux | grep cqpserver | awk '/-P "
Index: tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF	(revision 451)
+++ tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF	(revision 452)
@@ -7,7 +7,8 @@
  org.eclipse.core.runtime,
  org.txm.core;bundle-version="0.7.0",
  org.txm.searchengine.core;bundle-version="1.0.0",
- org.txm.libs.cqp;bundle-version="1.0.0"
+ org.txm.libs.cqp;bundle-version="1.0.0",
+ org.txm.utils;bundle-version="1.0.0"
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Bundle-ClassPath: res/,
  .
